<BLOCK>
<LICENSE>
/*  Capsim (r) Text Mode Kernel (TMK) Block Library (Blocks)
 *  Copyright (C) 1989-2017  Silicon DSP Corporation
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *    http://www.silicondsp.com
 *    Silicon DSP  Corporation
 *    Las Vegas, Nevada
 */

</LICENSE>

<BLOCK_NAME>
bits2sym
</BLOCK_NAME> 

<COMMENTS>
<![CDATA[ 

/* bits2sym.s */
/**********************************************************************
                            bits2sym()
   bits2sym is used to convert binary data into symbols 
***********************************************************************
*/
]]>
</COMMENTS> 

<INCLUDES>
<![CDATA[ 


]]>
</INCLUDES> 

<DEFINES> 


</DEFINES> 


<PARAMETERS>
	<PARAM>
		<DEF> Bits per Symbol </DEF>
		<TYPE> int </TYPE>
		<NAME> MM </NAME>
		<VALUE> 8 </VALUE>
	</PARAM>	
	
</PARAMETERS>



<DECLARATIONS> 

	int no_samples;
	int i;
	int j;
	int xbit;
	int byte;

</DECLARATIONS> 




<STATES>
	<STATE>
		<TYPE> int </TYPE>
		<NAME> obufs </NAME>
	</STATE>
	<STATE>
		<TYPE> int </TYPE>
		<NAME> count </NAME>
	</STATE>
	<STATE>
		<TYPE> int </TYPE>
		<NAME> xbyte </NAME>
	</STATE>
	<STATE>
		<TYPE> int* </TYPE>
		<NAME> dat </NAME>
	</STATE>
	
</STATES>



<INPUT_BUFFERS>
	<BUFFER>
		<TYPE> float </TYPE>
		<NAME> x </NAME>
	</BUFFER>
</INPUT_BUFFERS>

<INIT_CODE>
<![CDATA[ 

 
	/* note and store the number of output buffers */
	if((obufs = NO_OUTPUT_BUFFERS() ) <= 0) {
		fprintf(stderr,"bits2sym: no output buffers\n");
		return(1); /* no output buffers */
	}
  if ((dat = (int*)calloc(MM,sizeof(int))) == NULL)
  {
	fprintf(stderr,"bits2sym: can't allocate work space \n");
	return(4);
  }
  
  for (i=0; i<obufs; i++)  SET_CELL_SIZE_OUT(i,sizeof(int));
  

]]>
</INIT_CODE> 



<MAIN_CODE>
<![CDATA[ 


for(no_samples=MIN_AVAIL();no_samples >0; --no_samples) {

		IT_IN(0);
        xbit = (int) x(0);
		dat[count] = xbit;
		count++;

		
        if (count == MM)
		 {
		      count = 0;

		   
			  xbyte = 0;
			  for(j=0;j<MM;j++)
			       xbyte += dat[j] << j;

			
		      for(i=0;i<obufs;++i) {
			     if(IT_OUT(i) ) {
				       KrnOverflow("bits2sym",i);
				       return(99);
			     }
			     OUTI(i,0) = xbyte;

		       }
		
		
		}
      

}

return(0);  /* input buffer empty */


]]>
</MAIN_CODE> 

<WRAPUP_CODE>
<![CDATA[ 

free(dat);


]]>
</WRAPUP_CODE> 



</BLOCK> 

