#
# TCL Script that tabulates the BER for various SNR's
# The sys-ete-ber.t topology implements a QPSK digital communications link
# The number of bits is different for each SNR 
# The script demonstrates coupling of two different paramters per simulation.
# The script stores the results of each run in a list.
# At the end of the iteration loop the results are tabulated.
#
# Author: Sasan Ardalan
# June 25th, 2006
#

new

#BPSK
#set snrVals {1 2 3 4 5 6 7 8   }
#set bits { 10000 10000 100000 100000 100000 100000 1000000 1000000}

#64QAM
set snrVals {13 14 15 16  17 18 19 20 21 22  }
set bits {10000 10000 10000 10000 100000 100000 100000 100000 1000000 1000000}



arg 1 int 1 "Map"



capload digital_link_mapper_fec_snr.t

to scatter0
parambyname control 0

to plot1
parambyname control 0

to xplot 
parambyname control 0

to demapper0
parambyname soft 1



set berResults [list {}]
foreach snr  $snrVals numbits $bits {

   arg 0 int $numbits "Frame Size"
   set bitsFrame [expr $numbits+200+12] 
   arg 1 int 3 "Map"
   arg 2 int $bitsFrame  "bits"
 
     
    to cxsetsnr0
    parambyname snr $snr
    
    run
    puts -nonewline "$snr : $numbits "
    puts "BER=$ecountfap0_ber"
    
    lappend berResults [list $snr $ecountfap0_ber ]
    

}

puts [ llength $berResults ]
puts -nonewline SNR
puts -nonewline "\t"
puts   BER

foreach value $berResults {
   puts  -nonewline [lindex $value 0]
   puts  -nonewline "\t"
   puts   [lindex $value  1]

}
